[Nette Framework](https://nette.org)
===================================

[![Downloads this Month](https://img.shields.io/packagist/dm/nette/nette.svg)](https://packagist.org/packages/nette/nette)
[![Build Status](https://travis-ci.org/nette/nette.svg?branch=v2.1)](https://travis-ci.org/nette/nette)

Nette Framework is a popular tool for PHP web development. It is designed to be
as usable and as friendly as possible. It focuses on security and
performance and is definitely one of the safest PHP frameworks.

Nette Framework speaks your language and helps you to easily build better websites.


Requirements
------------

Nette Framework requires PHP 5.3.1 or later. Please run [Requirements
Checker](https://doc.nette.org/requirements) to obtain more detailed information.


Installation
------------

The best way to install Nette Framework is to download the latest package
from https://nette.org/download or use [Composer](https://doc.nette.org/composer).
The downloaded package includes the following directories:

- `Nette`: this directory contains the source code of Nette Framework. This is
	the only directory that you will need in order to deploy your application.

- `Nette-minified`: contains Nette Framework source code compressed into a single file.

- `client-side`: this directory contains the JavaScript source codes.

- `API-reference`: generated API documentation of the framework in HTML format. This is
    generated using [ApiGen](http://apigen.org) from the contents of the Nette directory.

- `examples`: contains some Nette Framework demo applications.

- `sandbox`: contains a pre-packaged Nette Framework project, basic configured
	structure for your application.

- `tests`: contains Nette Framework unit tests and testing tool.


Getting started
---------------

The [Quick Start tutorial](https://doc.nette.org/quickstart) gives you a first
introduction to the framework by creating a simple database driven application.
